<script lang="ts">
import Vue from 'vue';
import { toKebabCase } from '@/lib/utils';
import { UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'PartnersCopyBlock',
  mixins: [UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  methods: {
    toKebabCase,
    copyClipboard() {
      if (navigator) {
        navigator.clipboard.writeText(`${window.location}`);
      }
    },
  },
});
</script>

<template>
  <SlpContainer
    class="slp-mt-0 slp-mb-0"
    :class="data.top_margin || (!data.no_decoration && 'slp-mt-md-160')"
  >
    <SlpColumn :cols="data.column_size || 12">
      <div v-if="!data.no_decoration" class="decoration"></div>
      <SlpTypography
        v-if="data.header"
        :id="toKebabCase(data.anchor_id || data.header)"
        variant="heading2-bold"
        class="copy_block__header"
        tag="h2"
        >{{ data.header }}
        <a
          :href="`#${toKebabCase(data.anchor_id || data.header)}`"
          @click="copyClipboard()"
        >
          <SlpIcon icon="anchor" size="md" variant="marketing" />
        </a>
      </SlpTypography>
      <div class="copy_block__content copy">
        <div
          v-for="(block, index) in data.blocks"
          :key="`copy-block-${index}`"
          class="block"
        >
          <SlpTypography class="copy_block__text" variant="heading5" tag="div"
            ><div v-html="$md.render(block.text)"></div
          ></SlpTypography>
          <nuxt-img
            v-if="block.image"
            class="copy_block__image"
            :src="block.image.image_url"
            :alt="block.image.alt ? block.image.alt : ''"
            loading="lazy"
            format="webp"
            quality="99"
          />
          <div v-if="block.video" class="copy_block__video">
            <iframe
              :src="createVideoSource(block.video.video_url)"
              width="560"
              height="315"
              :title="data.header + ' YouTube Video'"
              allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
              allowfullscreen
            ></iframe>
          </div>
          <SlpButton
            v-if="block.link"
            :href="block.link.url"
            :data-ga-name="block.link.data_ga_name"
            data-ga-location="body"
            class="copy_block__button"
            >{{ block.link.text }}</SlpButton
          >
          <SlpButton
            v-if="block.secondary_link"
            :href="block.secondary_link.url"
            :data-ga-name="block.secondary_link.data_ga_name"
            data-ga-location="body"
            class="copy_block__button"
            variant="tertiary"
            >{{ block.secondary_link.text }}
            <SlpIcon
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
          /></SlpButton>
        </div>
      </div>
    </SlpColumn>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.copy_block {
  &__button {
    margin-top: $spacing-16;
  }
  &__header {
    margin-bottom: $spacing-32;
    a {
      opacity: 0;
      transition: opacity 170ms ease;
      color: inherit;
      display: inline-block;
    }
    &:hover,
    &:focus,
    &:active {
      a {
        opacity: 1;
        transition: opacity 170ms ease;
      }
    }
  }
  &__image {
    margin-top: $spacing-32;
    width: 100%;
  }
  &__video {
    width: 100%;
    display: flex;
    justify-content: center;
    margin-top: $spacing-32;
  }
  &__content {
    .block {
      margin-bottom: $spacing-16;
    }
  }
}
.decoration {
  height: 4px;
  margin-top: $spacing-32;
  width: 96px;
  border-radius: 20px;
  margin-bottom: $spacing-24;
  background: rgb(255, 203, 215);
  background: linear-gradient(
    90deg,
    rgba(255, 203, 215, 1) 0%,
    rgba(241, 205, 234, 1) 51%,
    rgba(211, 191, 238, 1) 100%
  );
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-64;
  }
}

.copy_block__text {
  &:deep ul {
    list-style: unset;
    padding: revert;
  }
  &:deep h3 {
    // Need to be important to override the typography styles for body-1 in the blocks where there is a small header (h4) in the paragraphs
    font-weight: 600 !important;
    font-size: 23px !important;
    line-height: 32px !important;
    margin-top: $spacing-32;
    margin-bottom: $spacing-24;
  }
  &:deep p {
    margin-bottom: $spacing-16;

    @media (max-width: $breakpoint-md) {
      font-size: $text-heading-5-mobile;
      line-height: $line-height-heading-5-mobile;
    }

    strong {
      font-weight: $font-weight-bold;
    }
  }
}
</style>
